scmUrlCopy = {}

local patterns = {
	"^(%a[%w%.+-]+://%S+)",
	"%f[%S](%a[%w%.+-]+://%S+)",
	"^(www%.[-%w_%%]+%.%S+)",
	"%f[%S](www%.[-%w_%%]+%.%S+)",
	"(%S+@[-%w_%%%.]+%.%a%a+)",
	"^([-%w_%%%.]+[-%w_%%]%.%a%a+/%S+)",
	"%f[%S]([-%w_%%%.]+[-%w_%%]%.%a%a+/%S+)",
	"^([-%w_%%%.]+[-%w_%%]%.%a%a+)",
	"%f[%S]([-%w_%%%.]+[-%w_%%]%.%a%a+)",
}

local currentLink
local _G = getfenv(0)
local origItemRef = nil

local tokennum, matchTable = 1, {}
local function registerMatch(text)
	local token = "\255\254\253"..tokennum.."\253\254\255"
	matchTable[token] = text:gsub("%%", "%%%%")
	tokennum = tokennum + 1
	return token
end

SCM_URL_STYLE = " |cffffffff|Hurl:%s|h[%s]|h|r "
local function match(link)
	if link == nil then return "" end
	return registerMatch(SCM_URL_STYLE:format(link, link))
end

local function filter(self, event, msg, ...)
	if not msg then return end
	for i, v in next, patterns do
		msg = msg:gsub(v, match)
	end
	for k,v in pairs(matchTable) do
		msg = msg:gsub(k, v)
		matchTable[k] = nil
	end
	return false, msg, ...
end

local function setItemRef(link, text, button)
	if link:sub(1, 3) == "url" then
		currentLink = link:sub(5)
		StaticPopup_Show("SCMUrlCopyDialog")
		return
	end
	return origItemRef(link, text, button)
end

function scmUrlCopy:Disable()
	if origItemRef then
		_G.SetItemRef = origItemRef
	end
end

function scmUrlCopy:Enable()
	ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER", filter)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_GUILD", filter)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_PARTY", filter)

	origItemRef = _G.SetItemRef
	_G.SetItemRef = setItemRef

	StaticPopupDialogs["SCMUrlCopyDialog"] = {
		text = "URL",
		button2 = TEXT(CLOSE),
		hasEditBox = 1,
		hasWideEditBox = 1,
		OnShow = function()
			local editBox = _G[this:GetName().."WideEditBox"]
			if editBox then
				editBox:SetText(currentLink)
				editBox:SetFocus()
				editBox:HighlightText(0)
			end
			local button = _G[this:GetName().."Button2"]
			if button then
				button:ClearAllPoints()
				button:SetWidth(200)
				button:SetPoint("CENTER", editBox, "CENTER", 0, -30)
			end
		end,
		EditBoxOnEscapePressed = function() this:GetParent():Hide() end,
		timeout = 0,
		whileDead = 1,
		hideOnEscape = 1,
	}
end

scmUrlCopy:Enable()

